


float sampleFrequency  ; 

//------------------------------------------------------------------------------------------------------
int itprun(int filno, int ix) ;

float fabs1(float x){
  if(x>0){ return x ; }
  return -x ;
  }

void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

float twopi = 3.1415926535 * 2;
int DDStable[4096] ;

float sampleFrequency  ; 
#define TXFRQ57 (57e3)
int TXddsFrequency57 ;
int TXddsPhase57 ;
int carrier57 ;

int clock57 ;
int t48 ;
int RDSpulse[48] ;
int sig=1 ;

volatile int ShiftReg ;
volatile int RDSbit=0 ;
volatile int BitsInShiftReg=1 ;

volatile int BitsInHoldReg=16 ;
volatile int HoldReg=0xAA55 ;
volatile int sig1 ;

int fil1 ;
int fil2 ;
int fil3 ;

#define TXtableSize 1024 
int TXtableData[TXtableSize] ;
int TXtableCount[TXtableSize] ;
int TXtableStorePtr=0 ;
int TXtableGetPtr=0 ;

inline void do24(){
  if (ShiftReg & 0x8000 ) { RDSbit=1-RDSbit ; } ;
  if (RDSbit) { sig1=1 ; } else { sig1=-1 ; } ;
  ShiftReg=ShiftReg<<1 ;
  BitsInShiftReg-- ;
  }

int m=0 ;

inline void do48(){
  if (BitsInShiftReg==0) { 
    BitsInShiftReg=TXtableCount[TXtableGetPtr] ; 
    ShiftReg=TXtableData[TXtableGetPtr] ; 
    TXtableGetPtr++ ;
    if(TXtableGetPtr>=TXtableStorePtr){ TXtableGetPtr=0 ; }
    BitsInHoldReg=0 ; 
    } 
  sig=sig1 ;
  }

inline void doRDSsample() {
  t48++ ;
  if(t48>=48){
    t48=0 ;
    do48() ;
    }
  if(t48==24){
    do24() ;
    }  
  }

 void TXtableInit() ;

int filteredVal1 ;
int filteredVal2 ;
int filteredVal3 ;

void TXloop(){
  int m ;
  while(1){
    m++ ;
    if(m>=200000){
      m=0 ;
    //  gpio_put(GPIO4, 1) ;
      TXtableInit() ;
    //  gpio_put(GPIO4, 0);
      }
      
    TXddsPhase57=TXddsPhase57+TXddsFrequency57 ;
    carrier57=DDStable[ (TXddsPhase57 >> 20 ) & 0xFFF ] ;
    if ( carrier57>5 )  { 
      if(clock57==0){
        // gpio_put(GPIO4, 1);
        doRDSsample() ;
     
        // gpio_put(GPIO4, 0);
        }
      clock57=1 ; 
      }
    if ( carrier57<-5)   { 
      clock57=0 ;
      }
    //int filteredVal=itprun(filter1,sig*RDSpulse[t48]) ;
    gpio_put(GPIO4, 1) ;
     filteredVal1=itprun(fil1,sig*RDSpulse[t48]) ;
        filteredVal2=itprun(fil2,filteredVal1) ;
    //int filteredVal3=itprun(fil3,filteredVal2) ;
    gpio_put(GPIO4, 0) ;
    int nextVal=filteredVal2*carrier57 ;
    //int nextVal=filteredVal2*30 ;
    //int nextVal=(sig*RDSpulse[t48]*carrier57) ;
    //int nextVal=(2048+((int)30*carrier57))  | (nSHDN<<12) | (nGA<<13) ;
    multicore_fifo_push_blocking( nextVal ) ;
    // gpio_put(GPIO4, 0);
    }
  }

void PutBlock(uint16_t w , uint16_t ofs){
uint8_t j ;
uint16_t Syndrom ; // rightmost 10 bits used ;
  // while(BitsInHoldReg!=0){} ; HoldReg=w ; BitsInHoldReg=16 ;
  TXtableData[TXtableStorePtr]=w ;
  TXtableCount[TXtableStorePtr]=16 ;
  TXtableStorePtr++ ;
  if(TXtableStorePtr>=TXtableSize){ printf("TXtable exhausted!") ; abort() ; }
  Syndrom=0 ;
  for (j=0 ; j<16 ; j++) {
    Syndrom=Syndrom<<1 ; // outgoing bit is at mask 0x0400
    if (w & 0x8000) { Syndrom ^= 0x0400 ; } // exor into outgoing bit
    w=w<<1 ;
    if ( Syndrom & 0x0400 ) { Syndrom ^= 0x1B9 ; }
    } ;
  Syndrom=(Syndrom^ofs)<<6 ;
  //while(BitsInHoldReg!=0){} ; HoldReg=Syndrom ; BitsInHoldReg=10 ;
  TXtableData[TXtableStorePtr]=Syndrom ;
  TXtableCount[TXtableStorePtr]=10 ;
  TXtableStorePtr++ ;
  if(TXtableStorePtr>=TXtableSize){ printf("TXtable exhausted!") ; abort() ; }
  }

void SendGroup(uint16_t a,uint16_t b,uint16_t c,uint16_t d){
  PutBlock(a,0x00fc) ; // block A
  PutBlock(b,0x0198) ; // block B
  PutBlock(c,0x0168) ; // block C
  PutBlock(d,0x01b4) ; // block D
  } 

void send_test(){
  while(BitsInHoldReg!=0){} ; 
  //HoldReg=0x8CF8 ; BitsInHoldReg=16 ;
  //HoldReg=0x0000 ; BitsInHoldReg=16 ;
  //HoldReg=0xFFFF ; BitsInHoldReg=16 ;
  HoldReg=0xAAAA ; BitsInHoldReg=16 ;
  }

char name[] = "OSSI-RDS";
char RDStextA[] = "RADIOTEXT IST OK         =cnt   ";
char RDStextB[] = "Das ist Text B. 1234567890abcde!";
uint8_t ms ;
uint8_t ta ;
uint8_t tp ;
uint16_t blkB ;
char txt[100] ;

#define AFfiller 0xCDCD
#define PIcode   0x1234
#define GRP0A    0x0000
#define GRP2A    0x2000
#define PTY      0x1

void send_group0(uint8_t k){
  blkB=(PTY<<5)+(ms<<3)+(tp<<10)+(ta<<4) ;
  SendGroup(PIcode,blkB+GRP0A+k, AFfiller, name[2*k+1]+(name[2*k+0]<<8) ) ; 
  }

void send_group2_textA(uint8_t k){
  int textAB=0<<4 ;
  blkB=(PTY<<5)+(tp<<10) ;
  SendGroup(PIcode,blkB+GRP2A+textAB+k, RDStextA[4*k+1]+(RDStextA[4*k+0]<<8),RDStextA[4*k+3]+(RDStextA[4*k+2]<<8)) ;
  }

void send_group2_textB(uint8_t k){
  int textAB=0x10 ;
  blkB=(PTY<<5)+(tp<<10) ;
  SendGroup(PIcode,blkB+GRP2A+textAB+k, RDStextB[4*k+1]+(RDStextB[4*k+0]<<8),RDStextB[4*k+3]+(RDStextB[4*k+2]<<8)) ;
  }

int count1=0 ;  

void TXtableInit(){
  ms=1 ;
  ta=0 ;
  tp=1 ;  
  TXtableStorePtr=0 ;

  send_group0(0) ;
  send_group0(1) ;
  send_group0(2) ;
  send_group0(3) ;
  send_group2_textA(0) ;
  send_group2_textA(1) ;
  send_group2_textA(2) ;
  send_group2_textA(3) ;
  send_group2_textA(4) ;
  send_group2_textA(5) ;
  send_group2_textA(6) ;
  send_group2_textA(7) ;  

  send_group2_textB(0) ;
  send_group2_textB(1) ;
  send_group2_textB(2) ;
  send_group2_textB(3) ;
  send_group2_textB(4) ;
  send_group2_textB(5) ;
  send_group2_textB(6) ;
  send_group2_textB(7) ;  

  count1++ ;
  sprintf(txt,"%04X",count1) ;
  RDStextA[20]=txt[0] ;
  RDStextA[21]=txt[1] ;
  RDStextA[22]=txt[2] ;
  RDStextA[23]=txt[3] ;
  } 

int toggle=0 ;
int count=0 ;
char txt[100] ;


//------------------------------------------------------------------------------------------------------



uint m_z=1234 ;
uint m_w=3456 ;

uint getRand(){
  m_z = 36969 * (m_z & 65535) + (m_z >> 16);
  m_w = 18000 * (m_w & 65535) + (m_w >> 16);
  return (m_z << 16) + m_w;  
  }

void initRand(){
  m_z=1234 ;
  m_w=3456 ;
  for(int k=0 ; k<32 ; k++){ 
     printf("rand()=%15d\n",getRand()) ; 
     }
  } 

//------------------------------------------------------------------------------------------------------

int IIRscale=1000 ;
int IIRscale2=10000 ;

#define maxsec 50 
#define maxfil 10 

int filtop=0 ;
int sectop=0  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;

float a0[maxfil]  ;
float w1[maxsec] ;
float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;

int iia0[maxsec]  ;
int iw1[maxsec] ;
int iw2[maxsec] ;
int ia1[maxsec] ;
int ia2[maxsec] ;
int ib1[maxsec] ;
int ib2[maxsec] ;

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  iw1[i]=0 ; 
  iw2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  printf("IIRfilter float\n") ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    //printf("i=%d\n",i) ;
    w11=w1[i] ; w22=w2[i] ;
    //printf("x=%10.3f w11=%10.3f w22=%10.3f\n",x,w11,w22) ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    //printf("w=%10.3f y=%10.3f\n",w,y) ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

int itprun(int filno, int ix){
  int i ; 
  int iw,iw11,iw22,iy ;
  iy=0 ;
  //printf("IIRfilter int\n") ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    //printf("i=%d\n",i) ;
    iw11=iw1[i] ; iw22=iw2[i] ;
    //printf("ix=%10d iw11=%10d iw22=%10d\n",ix,iw11,iw22) ;
    //println("******** ib1[i]*iw11+ib2[i]*i="+(ib1[i]*iw11+ib2[i]*iw22)) ;
    iw=ix-(ib1[i]*iw11+ib2[i]*iw22)/IIRscale  ;
         
    iy=iw+2*iw11+iw22 ;
    //println("iw="+iw+" iy="+iy) ;
    iw2[i]=iw11 ; iw1[i]=iw ; 
    ix=(iia0[i]*iy)/IIRscale2 ;
    }
  return ix ;
  }


float sqr(float x){ return x*x ; }

int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

  if ((nord % 2)!=0){ printf("nord wrong in Butter") ; }
filtop++ ;
 if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("nord=%d nsec=%d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  printf("i=%d\n",i) ;
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  //println("t="+t+" w="+w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;

  ib1[sectop]=(int)(IIRscale*(-2*u)) ;
  ib2[sectop]=(int)(IIRscale*(u*u+v*v)) ;


  printf("b1=%15.7f b2=%15.7f\n",b1[sectop],b2[sectop]) ;
      printf("ib1=%15d ib2=%15d\n",ib1[sectop],ib2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;

  ia1[sectop]=2 ; 
  ia2[sectop]=1 ;

  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
   printf("a0x=%10.5f",a0x) ;
  }
printf("IIRscale*a0^(1/nsec)=%15.8f\n",IIRscale2*pow(a0x,1.0/nsec) ) ;
a0[filtop]=a0x ;
for (i=secstart[filtop] ; i<secstart[filtop]+seccnt[filtop] ; i++){
  iia0[i]=(int)(IIRscale2*pow(a0x,1.0/nsec)) ;
  printf("iia0=%d\n",iia0[i]) ;
  }
return filtop ;
}


int tscheby(int nord, float  frq, float rip){
    int i,nsec ; 
    float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;
    if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
    filtop++ ;
    if( filtop>maxfil){ printf("maxfil error") ; }
    nsec=nord / 2 ;
    secstart[filtop]=sectop+1 ;
    seccnt[filtop]=nsec ;

    a0x=1.0 ;
    eps=sqrt(1/sqr(1-rip)-1) ;
    s1=sqrt(1/sqr(eps)+1)+1/eps ;
    s1=exp(log(s1)/nord) ;
    s2=1/s1 ; 
    a=0.5*(s1-s2) ;
    b=0.5*(s1+s2) ;
    for (i=nord ; i<=3*nsec-1 ; i++){
      printf("i=%d\n",i) ;
      t=(2*i+1.0)/(2.0*nord)*M_PI ;
      c1=M_PI*frq ;
      w=sin(c1)/cos(c1) ;
      ww=w*w ;
      u=1-a*w*cos(t) ;
      d=u*u+b*b*ww*sqr(sin(t)) ;
      u=2*u/d-1 ;
      v=2*b*w*sin(t)/d ;
      sectop++ ;
      b1[sectop]=-2*u ;
      b2[sectop]=u*u+v*v ;
      ib1[sectop]=(int)(IIRscale*(-2*u)) ;
      ib2[sectop]=(int)(IIRscale*(u*u+v*v)) ;
  
      printf("b1=%15.7f b2=%15.7f\n",b1[sectop],b2[sectop]) ;
      printf("ib1=%15d ib2=%15d\n",ib1[sectop],ib2[sectop]) ;
      a1[sectop]=2 ; 
      a2[sectop]=1 ;
      ia1[sectop]=2 ; 
      ia2[sectop]=1 ;
  
      a0x=a0x*(1-2*u+u*u+v*v)/4.0 ;
      printf("a0x=%10.5f",a0x) ;
      }
  //println("a0="+a0x) ;
  printf("IIRscale*a0^(1/nsec)=%15.8f\n",IIRscale2*pow(a0x,1.0/nsec) ) ;
  a0[filtop]=a0x ;
  
  for (i=secstart[filtop] ; i<secstart[filtop]+seccnt[filtop] ; i++){
    iia0[i]=(int)(IIRscale2*pow(a0x,1.0/nsec)) ;
    printf("iia0=%d\n",iia0[i]) ;
    }
  return filtop ;
  }

//------------------------------------------------------------------------------------------------------


void core1_entry() {
  printf("Hello, multicore core1_entry DDS generator()!\n");
 
  for(int k=0 ; k<4096 ; k++){
    DDStable[k]=60.0*sin(twopi*k/4096.0) ;
    // if(DDStable[k]>0){ DDStable[k]=1000 ; }  else { DDStable[k]=-1000 ; }
    }

  for(int k=0 ; k<48 ; k++){
    //if(k<24) { RDSpulse[k]=1 ; } else { RDSpulse[k]=-1 ; }
    RDSpulse[k]=50*sin((k-24.0)*twopi/48.0) ;
   // if(RDSpulse[k]>0){ RDSpulse[k]=30 ; } else { RDSpulse[k]=-30 ; }
   float xabs=fabs1(k-23) ;
   float v=cos(xabs*M_PI/48) ;
   v=v*v ;
  // RDSpulse[k]=v*60*sin((k-24.0)*twopi/48.0) ;
    }  

  TXddsPhase57=0 ;
  // TXddsPhase19=0 ;
  // TXddsFrequency19=TXFRQ19/sampleFrequency*(double)(0x100000000L) ;
  TXddsFrequency57=TXFRQ57/sampleFrequency*(double)(0x100000000L) ;
  clock57=0 ;
  t48=0 ;
  sig=1 ;


  initRand() ;

/*
  fil1=tscheby(2,1.2/200.0,0.5) ;
  tpreset(fil1) ;
  fil2=tscheby(2,1.2/200.0,0.5) ;
  tpreset(fil2) ;
*/

  fil1=butter(2,1.2/200.0) ;
  tpreset(fil1) ;
  fil2=butter(2,1.2/200.0) ;
  tpreset(fil2) ;
  fil3=butter(2,1.2/200.0) ;
  tpreset(fil3) ;


  TXtableInit() ;
  TXloop() ;

  }

